import { DefinePlugin, HotModuleReplacementPlugin, ProgressPlugin } from 'webpack';
import Dotenv from 'dotenv-webpack';
import HtmlWebpackPlugin from 'html-webpack-plugin';
import CaseSensitivePathsPlugin from 'case-sensitive-paths-webpack-plugin';
import WatchMissingNodeModulesPlugin from 'react-dev-utils/WatchMissingNodeModulesPlugin';
import TerserWebpackPlugin from 'terser-webpack-plugin';
import VirtualModulePlugin from 'webpack-virtual-modules';
import ForkTsCheckerWebpackPlugin from 'fork-ts-checker-webpack-plugin';
declare const _default: ({ configDir, babelOptions, entries, stories, outputDir, quiet, packageJson, configType, framework, frameworkPath, presets, typescriptOptions, }: any) => Promise<{
    mode: string;
    bail: boolean;
    devtool: string;
    entry: any;
    output: {
        path: string;
        filename: string;
        publicPath: string;
    };
    plugins: (ProgressPlugin | Dotenv | HtmlWebpackPlugin | CaseSensitivePathsPlugin | VirtualModulePlugin | DefinePlugin | WatchMissingNodeModulesPlugin | ForkTsCheckerWebpackPlugin | HotModuleReplacementPlugin)[];
    module: {
        rules: (import("webpack").RuleSetRule | {
            test: RegExp;
            use: {
                loader: string;
                options: any;
            }[];
            include: string[];
            exclude: RegExp;
        })[];
    };
    resolve: {
        extensions: string[];
        modules: string[];
        alias: any;
        plugins: any[];
    };
    resolveLoader: {
        plugins: any[];
    };
    optimization: {
        splitChunks: {
            chunks: string;
        };
        runtimeChunk: boolean;
        minimizer: TerserWebpackPlugin[];
    };
    performance: {
        hints: string | boolean;
    };
}>;
export default _default;
